//
// Automatically generated by the IPDL compiler.
// Edit at your own risk
//

#ifndef PTestArrays_h
#define PTestArrays_h

#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"

//-----------------------------------------------------------------------------
// Definition of the IPDL type |union IntDouble|
//
namespace mozilla {
namespace _ipdltest {
class NS_FINAL_CLASS IntDouble
{
public:
    enum Type {
        T__None,
        Tint = 1,
        Tdouble,
        T__First = Tint,
        T__Last = Tdouble
    };

private:
    typedef int int__tdef;
    typedef double double__tdef;

    union Value {
        char Vint[sizeof(int)];
        char Vdouble[sizeof(double)];
    };

    int*
    ptr_int()
    {
        return reinterpret_cast<int*>((&((mValue).Vint)));
    }
    const int* const
    constptr_int() const
    {
        return reinterpret_cast<const int* const>((&((mValue).Vint)));
    }
    double*
    ptr_double()
    {
        return reinterpret_cast<double*>((&((mValue).Vdouble)));
    }
    const double* const
    constptr_double() const
    {
        return reinterpret_cast<const double* const>((&((mValue).Vdouble)));
    }

    bool
    MaybeDestroy(Type aNewType)
    {
        if ((mType) == (T__None)) {
            return true;
        }
        if ((mType) == (aNewType)) {
            return false;
        }
        switch (mType) {
        case Tint:
            {
                (ptr_int())->~int__tdef();
                break;
            }
        case Tdouble:
            {
                (ptr_double())->~double__tdef();
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("not reached");
                break;
            }
        }
        return true;
    }

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__First) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    IntDouble() :
        mType(T__None)
    {
    }

    IntDouble(const int& aOther)
    {
        new (ptr_int()) int(aOther);
        mType = Tint;
    }

    IntDouble(const double& aOther)
    {
        new (ptr_double()) double(aOther);
        mType = Tdouble;
    }

    IntDouble(const IntDouble& aOther)
    {
        (aOther).AssertSanity();
        switch ((aOther).type()) {
        case Tint:
            {
                new (ptr_int()) int((aOther).get_int());
                break;
            }
        case Tdouble:
            {
                new (ptr_double()) double((aOther).get_double());
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return;
            }
        }
        mType = (aOther).type();
    }

    ~IntDouble()
    {
        MaybeDestroy(T__None);
    }

    Type
    type() const
    {
        return mType;
    }

    IntDouble&
    operator=(const int& aRhs)
    {
        if (MaybeDestroy(Tint)) {
            new (ptr_int()) int;
        }
        (*(ptr_int())) = aRhs;
        mType = Tint;
        return (*(this));
    }

    IntDouble&
    operator=(const double& aRhs)
    {
        if (MaybeDestroy(Tdouble)) {
            new (ptr_double()) double;
        }
        (*(ptr_double())) = aRhs;
        mType = Tdouble;
        return (*(this));
    }

    IntDouble&
    operator=(const IntDouble& aRhs)
    {
        (aRhs).AssertSanity();
        Type t = (aRhs).type();
        switch (t) {
        case Tint:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_int()) int;
                }
                (*(ptr_int())) = (aRhs).get_int();
                break;
            }
        case Tdouble:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_double()) double;
                }
                (*(ptr_double())) = (aRhs).get_double();
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                break;
            }
        }
        mType = t;
        return (*(this));
    }

    int&
    get_int()
    {
        AssertSanity(Tint);
        return (*(ptr_int()));
    }
    const int&
    get_int() const
    {
        AssertSanity(Tint);
        return (*(constptr_int()));
    }
    operator int&()
    {
        return get_int();
    }
    operator const int&() const
    {
        return get_int();
    }

    double&
    get_double()
    {
        AssertSanity(Tdouble);
        return (*(ptr_double()));
    }
    const double&
    get_double() const
    {
        AssertSanity(Tdouble);
        return (*(constptr_double()));
    }
    operator double&()
    {
        return get_double();
    }
    operator const double&() const
    {
        return get_double();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace _ipdltest
} // namespace mozilla

//
// serializer/deserializer
//
namespace IPC {
template<>
struct ParamTraits <mozilla::_ipdltest::IntDouble>
{
private:

public:
    typedef mozilla::_ipdltest::IntDouble paramType;

    static void
    Write(
            Message* aMsg,
            const paramType& aParam)
    {
        WriteParam(aMsg, static_cast<int>((aParam).type()));
        switch ((aParam).type()) {
        case paramType::Tint:
            {
                WriteParam(aMsg, (aParam).get_int());
                break;
            }
        case paramType::Tdouble:
            {
                WriteParam(aMsg, (aParam).get_double());
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return;
            }
        }
    }

    static bool
    Read(
            const Message* aMsg,
            void** aIter,
            paramType* aParam)
    {
        int type;
        if ((!((ReadParam(aMsg, aIter, (&(type)))) && (((paramType::T__First) <= (type)) && ((type) <= (paramType::T__Last)))))) {
            return false;
        }

        switch (type) {
        case paramType::Tint:
            {
                int val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        case paramType::Tdouble:
            {
                double val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return false;
            }
        }

    }

    static void
    Log(
            const paramType& aParam,
            std::wstring* aLog)
    {
        (aLog)->append(L"(IntDouble)");
    }
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Definition of the IPDL type |union IntDoubleArrays|
//
namespace mozilla {
namespace _ipdltest {
class NS_FINAL_CLASS IntDoubleArrays
{
public:
    enum Type {
        T__None,
        Tint = 1,
        TArrayOfint,
        TArrayOfdouble,
        T__First = Tint,
        T__Last = TArrayOfdouble
    };

private:
    typedef int int__tdef;
    typedef nsTArray<int> ArrayOfint__tdef;
    typedef nsTArray<double> ArrayOfdouble__tdef;

    union Value {
        char Vint[sizeof(int)];
        char VArrayOfint[sizeof(nsTArray<int>)];
        char VArrayOfdouble[sizeof(nsTArray<double>)];
    };

    int*
    ptr_int()
    {
        return reinterpret_cast<int*>((&((mValue).Vint)));
    }
    const int* const
    constptr_int() const
    {
        return reinterpret_cast<const int* const>((&((mValue).Vint)));
    }
    nsTArray<int>*
    ptr_ArrayOfint()
    {
        return reinterpret_cast<nsTArray<int>*>((&((mValue).VArrayOfint)));
    }
    const nsTArray<int>* const
    constptr_ArrayOfint() const
    {
        return reinterpret_cast<const nsTArray<int>* const>((&((mValue).VArrayOfint)));
    }
    nsTArray<double>*
    ptr_ArrayOfdouble()
    {
        return reinterpret_cast<nsTArray<double>*>((&((mValue).VArrayOfdouble)));
    }
    const nsTArray<double>* const
    constptr_ArrayOfdouble() const
    {
        return reinterpret_cast<const nsTArray<double>* const>((&((mValue).VArrayOfdouble)));
    }

    bool
    MaybeDestroy(Type aNewType)
    {
        if ((mType) == (T__None)) {
            return true;
        }
        if ((mType) == (aNewType)) {
            return false;
        }
        switch (mType) {
        case Tint:
            {
                (ptr_int())->~int__tdef();
                break;
            }
        case TArrayOfint:
            {
                (ptr_ArrayOfint())->~ArrayOfint__tdef();
                break;
            }
        case TArrayOfdouble:
            {
                (ptr_ArrayOfdouble())->~ArrayOfdouble__tdef();
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("not reached");
                break;
            }
        }
        return true;
    }

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__First) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    IntDoubleArrays() :
        mType(T__None)
    {
    }

    IntDoubleArrays(const int& aOther)
    {
        new (ptr_int()) int(aOther);
        mType = Tint;
    }

    IntDoubleArrays(const nsTArray<int>& aOther)
    {
        new (ptr_ArrayOfint()) nsTArray<int>(aOther);
        mType = TArrayOfint;
    }

    IntDoubleArrays(const nsTArray<double>& aOther)
    {
        new (ptr_ArrayOfdouble()) nsTArray<double>(aOther);
        mType = TArrayOfdouble;
    }

    IntDoubleArrays(const IntDoubleArrays& aOther)
    {
        (aOther).AssertSanity();
        switch ((aOther).type()) {
        case Tint:
            {
                new (ptr_int()) int((aOther).get_int());
                break;
            }
        case TArrayOfint:
            {
                new (ptr_ArrayOfint()) nsTArray<int>((aOther).get_ArrayOfint());
                break;
            }
        case TArrayOfdouble:
            {
                new (ptr_ArrayOfdouble()) nsTArray<double>((aOther).get_ArrayOfdouble());
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return;
            }
        }
        mType = (aOther).type();
    }

    ~IntDoubleArrays()
    {
        MaybeDestroy(T__None);
    }

    Type
    type() const
    {
        return mType;
    }

    IntDoubleArrays&
    operator=(const int& aRhs)
    {
        if (MaybeDestroy(Tint)) {
            new (ptr_int()) int;
        }
        (*(ptr_int())) = aRhs;
        mType = Tint;
        return (*(this));
    }

    IntDoubleArrays&
    operator=(const nsTArray<int>& aRhs)
    {
        if (MaybeDestroy(TArrayOfint)) {
            new (ptr_ArrayOfint()) nsTArray<int>;
        }
        (*(ptr_ArrayOfint())) = aRhs;
        mType = TArrayOfint;
        return (*(this));
    }

    IntDoubleArrays&
    operator=(const nsTArray<double>& aRhs)
    {
        if (MaybeDestroy(TArrayOfdouble)) {
            new (ptr_ArrayOfdouble()) nsTArray<double>;
        }
        (*(ptr_ArrayOfdouble())) = aRhs;
        mType = TArrayOfdouble;
        return (*(this));
    }

    IntDoubleArrays&
    operator=(const IntDoubleArrays& aRhs)
    {
        (aRhs).AssertSanity();
        Type t = (aRhs).type();
        switch (t) {
        case Tint:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_int()) int;
                }
                (*(ptr_int())) = (aRhs).get_int();
                break;
            }
        case TArrayOfint:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_ArrayOfint()) nsTArray<int>;
                }
                (*(ptr_ArrayOfint())) = (aRhs).get_ArrayOfint();
                break;
            }
        case TArrayOfdouble:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_ArrayOfdouble()) nsTArray<double>;
                }
                (*(ptr_ArrayOfdouble())) = (aRhs).get_ArrayOfdouble();
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                break;
            }
        }
        mType = t;
        return (*(this));
    }

    int&
    get_int()
    {
        AssertSanity(Tint);
        return (*(ptr_int()));
    }
    const int&
    get_int() const
    {
        AssertSanity(Tint);
        return (*(constptr_int()));
    }
    operator int&()
    {
        return get_int();
    }
    operator const int&() const
    {
        return get_int();
    }

    nsTArray<int>&
    get_ArrayOfint()
    {
        AssertSanity(TArrayOfint);
        return (*(ptr_ArrayOfint()));
    }
    const nsTArray<int>&
    get_ArrayOfint() const
    {
        AssertSanity(TArrayOfint);
        return (*(constptr_ArrayOfint()));
    }
    operator nsTArray<int>&()
    {
        return get_ArrayOfint();
    }
    operator const nsTArray<int>&() const
    {
        return get_ArrayOfint();
    }

    nsTArray<double>&
    get_ArrayOfdouble()
    {
        AssertSanity(TArrayOfdouble);
        return (*(ptr_ArrayOfdouble()));
    }
    const nsTArray<double>&
    get_ArrayOfdouble() const
    {
        AssertSanity(TArrayOfdouble);
        return (*(constptr_ArrayOfdouble()));
    }
    operator nsTArray<double>&()
    {
        return get_ArrayOfdouble();
    }
    operator const nsTArray<double>&() const
    {
        return get_ArrayOfdouble();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace _ipdltest
} // namespace mozilla

//
// serializer/deserializer
//
namespace IPC {
template<>
struct ParamTraits <mozilla::_ipdltest::IntDoubleArrays>
{
private:

public:
    typedef mozilla::_ipdltest::IntDoubleArrays paramType;

    static void
    Write(
            Message* aMsg,
            const paramType& aParam)
    {
        WriteParam(aMsg, static_cast<int>((aParam).type()));
        switch ((aParam).type()) {
        case paramType::Tint:
            {
                WriteParam(aMsg, (aParam).get_int());
                break;
            }
        case paramType::TArrayOfint:
            {
                WriteParam(aMsg, (aParam).get_ArrayOfint());
                break;
            }
        case paramType::TArrayOfdouble:
            {
                WriteParam(aMsg, (aParam).get_ArrayOfdouble());
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return;
            }
        }
    }

    static bool
    Read(
            const Message* aMsg,
            void** aIter,
            paramType* aParam)
    {
        int type;
        if ((!((ReadParam(aMsg, aIter, (&(type)))) && (((paramType::T__First) <= (type)) && ((type) <= (paramType::T__Last)))))) {
            return false;
        }

        switch (type) {
        case paramType::Tint:
            {
                int val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        case paramType::TArrayOfint:
            {
                nsTArray<int> val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        case paramType::TArrayOfdouble:
            {
                nsTArray<double> val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return false;
            }
        }

    }

    static void
    Log(
            const paramType& aParam,
            std::wstring* aLog)
    {
        (aLog)->append(L"(IntDoubleArrays)");
    }
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Definition of the IPDL type |union Actors|
//
namespace mozilla {
namespace _ipdltest {
class PTestArraysSubParent;
} // namespace _ipdltest
} // namespace mozilla

namespace mozilla {
namespace _ipdltest {
class PTestArraysSubChild;
} // namespace _ipdltest
} // namespace mozilla

namespace mozilla {
namespace _ipdltest {
class NS_FINAL_CLASS Actors
{
public:
    enum Type {
        T__None,
        Tint = 1,
        TArrayOfint,
        TArrayOfPTestArraysSubParent,
        TArrayOfPTestArraysSubChild,
        T__First = Tint,
        T__Last = TArrayOfPTestArraysSubChild
    };

private:
    typedef mozilla::_ipdltest::PTestArraysSubParent PTestArraysSubParent;
    typedef mozilla::_ipdltest::PTestArraysSubChild PTestArraysSubChild;
    typedef int int__tdef;
    typedef nsTArray<int> ArrayOfint__tdef;
    typedef nsTArray<PTestArraysSubParent*> ArrayOfPTestArraysSubParent__tdef;
    typedef nsTArray<PTestArraysSubChild*> ArrayOfPTestArraysSubChild__tdef;

    union Value {
        char Vint[sizeof(int)];
        char VArrayOfint[sizeof(nsTArray<int>)];
        char VArrayOfPTestArraysSubParent[sizeof(nsTArray<PTestArraysSubParent*>)];
        char VArrayOfPTestArraysSubChild[sizeof(nsTArray<PTestArraysSubChild*>)];
    };

    int*
    ptr_int()
    {
        return reinterpret_cast<int*>((&((mValue).Vint)));
    }
    const int* const
    constptr_int() const
    {
        return reinterpret_cast<const int* const>((&((mValue).Vint)));
    }
    nsTArray<int>*
    ptr_ArrayOfint()
    {
        return reinterpret_cast<nsTArray<int>*>((&((mValue).VArrayOfint)));
    }
    const nsTArray<int>* const
    constptr_ArrayOfint() const
    {
        return reinterpret_cast<const nsTArray<int>* const>((&((mValue).VArrayOfint)));
    }
    nsTArray<PTestArraysSubParent*>*
    ptr_ArrayOfPTestArraysSubParent()
    {
        return reinterpret_cast<nsTArray<PTestArraysSubParent*>*>((&((mValue).VArrayOfPTestArraysSubParent)));
    }
    const nsTArray<PTestArraysSubParent*>* const
    constptr_ArrayOfPTestArraysSubParent() const
    {
        return reinterpret_cast<const nsTArray<PTestArraysSubParent*>* const>((&((mValue).VArrayOfPTestArraysSubParent)));
    }
    nsTArray<PTestArraysSubChild*>*
    ptr_ArrayOfPTestArraysSubChild()
    {
        return reinterpret_cast<nsTArray<PTestArraysSubChild*>*>((&((mValue).VArrayOfPTestArraysSubChild)));
    }
    const nsTArray<PTestArraysSubChild*>* const
    constptr_ArrayOfPTestArraysSubChild() const
    {
        return reinterpret_cast<const nsTArray<PTestArraysSubChild*>* const>((&((mValue).VArrayOfPTestArraysSubChild)));
    }

    bool
    MaybeDestroy(Type aNewType)
    {
        if ((mType) == (T__None)) {
            return true;
        }
        if ((mType) == (aNewType)) {
            return false;
        }
        switch (mType) {
        case Tint:
            {
                (ptr_int())->~int__tdef();
                break;
            }
        case TArrayOfint:
            {
                (ptr_ArrayOfint())->~ArrayOfint__tdef();
                break;
            }
        case TArrayOfPTestArraysSubParent:
            {
                (ptr_ArrayOfPTestArraysSubParent())->~ArrayOfPTestArraysSubParent__tdef();
                break;
            }
        case TArrayOfPTestArraysSubChild:
            {
                (ptr_ArrayOfPTestArraysSubChild())->~ArrayOfPTestArraysSubChild__tdef();
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("not reached");
                break;
            }
        }
        return true;
    }

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__First) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    Actors() :
        mType(T__None)
    {
    }

    Actors(const int& aOther)
    {
        new (ptr_int()) int(aOther);
        mType = Tint;
    }

    Actors(const nsTArray<int>& aOther)
    {
        new (ptr_ArrayOfint()) nsTArray<int>(aOther);
        mType = TArrayOfint;
    }

    Actors(const nsTArray<PTestArraysSubParent*>& aOther)
    {
        new (ptr_ArrayOfPTestArraysSubParent()) nsTArray<PTestArraysSubParent*>(aOther);
        mType = TArrayOfPTestArraysSubParent;
    }

    Actors(const nsTArray<PTestArraysSubChild*>& aOther)
    {
        new (ptr_ArrayOfPTestArraysSubChild()) nsTArray<PTestArraysSubChild*>(aOther);
        mType = TArrayOfPTestArraysSubChild;
    }

    Actors(const Actors& aOther)
    {
        (aOther).AssertSanity();
        switch ((aOther).type()) {
        case Tint:
            {
                new (ptr_int()) int((aOther).get_int());
                break;
            }
        case TArrayOfint:
            {
                new (ptr_ArrayOfint()) nsTArray<int>((aOther).get_ArrayOfint());
                break;
            }
        case TArrayOfPTestArraysSubParent:
            {
                new (ptr_ArrayOfPTestArraysSubParent()) nsTArray<PTestArraysSubParent*>((aOther).get_ArrayOfPTestArraysSubParent());
                break;
            }
        case TArrayOfPTestArraysSubChild:
            {
                new (ptr_ArrayOfPTestArraysSubChild()) nsTArray<PTestArraysSubChild*>((aOther).get_ArrayOfPTestArraysSubChild());
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return;
            }
        }
        mType = (aOther).type();
    }

    ~Actors()
    {
        MaybeDestroy(T__None);
    }

    Type
    type() const
    {
        return mType;
    }

    Actors&
    operator=(const int& aRhs)
    {
        if (MaybeDestroy(Tint)) {
            new (ptr_int()) int;
        }
        (*(ptr_int())) = aRhs;
        mType = Tint;
        return (*(this));
    }

    Actors&
    operator=(const nsTArray<int>& aRhs)
    {
        if (MaybeDestroy(TArrayOfint)) {
            new (ptr_ArrayOfint()) nsTArray<int>;
        }
        (*(ptr_ArrayOfint())) = aRhs;
        mType = TArrayOfint;
        return (*(this));
    }

    Actors&
    operator=(const nsTArray<PTestArraysSubParent*>& aRhs)
    {
        if (MaybeDestroy(TArrayOfPTestArraysSubParent)) {
            new (ptr_ArrayOfPTestArraysSubParent()) nsTArray<PTestArraysSubParent*>;
        }
        (*(ptr_ArrayOfPTestArraysSubParent())) = aRhs;
        mType = TArrayOfPTestArraysSubParent;
        return (*(this));
    }

    Actors&
    operator=(const nsTArray<PTestArraysSubChild*>& aRhs)
    {
        if (MaybeDestroy(TArrayOfPTestArraysSubChild)) {
            new (ptr_ArrayOfPTestArraysSubChild()) nsTArray<PTestArraysSubChild*>;
        }
        (*(ptr_ArrayOfPTestArraysSubChild())) = aRhs;
        mType = TArrayOfPTestArraysSubChild;
        return (*(this));
    }

    Actors&
    operator=(const Actors& aRhs)
    {
        (aRhs).AssertSanity();
        Type t = (aRhs).type();
        switch (t) {
        case Tint:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_int()) int;
                }
                (*(ptr_int())) = (aRhs).get_int();
                break;
            }
        case TArrayOfint:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_ArrayOfint()) nsTArray<int>;
                }
                (*(ptr_ArrayOfint())) = (aRhs).get_ArrayOfint();
                break;
            }
        case TArrayOfPTestArraysSubParent:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_ArrayOfPTestArraysSubParent()) nsTArray<PTestArraysSubParent*>;
                }
                (*(ptr_ArrayOfPTestArraysSubParent())) = (aRhs).get_ArrayOfPTestArraysSubParent();
                break;
            }
        case TArrayOfPTestArraysSubChild:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_ArrayOfPTestArraysSubChild()) nsTArray<PTestArraysSubChild*>;
                }
                (*(ptr_ArrayOfPTestArraysSubChild())) = (aRhs).get_ArrayOfPTestArraysSubChild();
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                break;
            }
        }
        mType = t;
        return (*(this));
    }

    int&
    get_int()
    {
        AssertSanity(Tint);
        return (*(ptr_int()));
    }
    const int&
    get_int() const
    {
        AssertSanity(Tint);
        return (*(constptr_int()));
    }
    operator int&()
    {
        return get_int();
    }
    operator const int&() const
    {
        return get_int();
    }

    nsTArray<int>&
    get_ArrayOfint()
    {
        AssertSanity(TArrayOfint);
        return (*(ptr_ArrayOfint()));
    }
    const nsTArray<int>&
    get_ArrayOfint() const
    {
        AssertSanity(TArrayOfint);
        return (*(constptr_ArrayOfint()));
    }
    operator nsTArray<int>&()
    {
        return get_ArrayOfint();
    }
    operator const nsTArray<int>&() const
    {
        return get_ArrayOfint();
    }

    nsTArray<PTestArraysSubParent*>&
    get_ArrayOfPTestArraysSubParent()
    {
        AssertSanity(TArrayOfPTestArraysSubParent);
        return (*(ptr_ArrayOfPTestArraysSubParent()));
    }
    const nsTArray<PTestArraysSubParent*>&
    get_ArrayOfPTestArraysSubParent() const
    {
        AssertSanity(TArrayOfPTestArraysSubParent);
        return (*(constptr_ArrayOfPTestArraysSubParent()));
    }
    operator nsTArray<PTestArraysSubParent*>&()
    {
        return get_ArrayOfPTestArraysSubParent();
    }
    operator const nsTArray<PTestArraysSubParent*>&() const
    {
        return get_ArrayOfPTestArraysSubParent();
    }

    nsTArray<PTestArraysSubChild*>&
    get_ArrayOfPTestArraysSubChild()
    {
        AssertSanity(TArrayOfPTestArraysSubChild);
        return (*(ptr_ArrayOfPTestArraysSubChild()));
    }
    const nsTArray<PTestArraysSubChild*>&
    get_ArrayOfPTestArraysSubChild() const
    {
        AssertSanity(TArrayOfPTestArraysSubChild);
        return (*(constptr_ArrayOfPTestArraysSubChild()));
    }
    operator nsTArray<PTestArraysSubChild*>&()
    {
        return get_ArrayOfPTestArraysSubChild();
    }
    operator const nsTArray<PTestArraysSubChild*>&() const
    {
        return get_ArrayOfPTestArraysSubChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace _ipdltest
} // namespace mozilla

//
// serializer/deserializer
//
namespace IPC {
template<>
struct ParamTraits <mozilla::_ipdltest::Actors>
{
private:
    typedef mozilla::_ipdltest::PTestArraysSubParent PTestArraysSubParent;
    typedef mozilla::_ipdltest::PTestArraysSubChild PTestArraysSubChild;

public:
    typedef mozilla::_ipdltest::Actors paramType;

    static void
    Write(
            Message* aMsg,
            const paramType& aParam)
    {
        WriteParam(aMsg, static_cast<int>((aParam).type()));
        switch ((aParam).type()) {
        case paramType::Tint:
            {
                WriteParam(aMsg, (aParam).get_int());
                break;
            }
        case paramType::TArrayOfint:
            {
                WriteParam(aMsg, (aParam).get_ArrayOfint());
                break;
            }
        case paramType::TArrayOfPTestArraysSubParent:
            {
                uint32 len = ((aParam).get_ArrayOfPTestArraysSubParent()).Length();
                WriteParam(aMsg, len);
                (aMsg)->WriteBytes(reinterpret_cast<const void*>(((aParam).get_ArrayOfPTestArraysSubParent()).Elements()), (len) * (sizeof(intptr_t)));
                break;
            }
        case paramType::TArrayOfPTestArraysSubChild:
            {
                uint32 len = ((aParam).get_ArrayOfPTestArraysSubChild()).Length();
                WriteParam(aMsg, len);
                (aMsg)->WriteBytes(reinterpret_cast<const void*>(((aParam).get_ArrayOfPTestArraysSubChild()).Elements()), (len) * (sizeof(intptr_t)));
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return;
            }
        }
    }

    static bool
    Read(
            const Message* aMsg,
            void** aIter,
            paramType* aParam)
    {
        int type;
        if ((!((ReadParam(aMsg, aIter, (&(type)))) && (((paramType::T__First) <= (type)) && ((type) <= (paramType::T__Last)))))) {
            return false;
        }

        switch (type) {
        case paramType::Tint:
            {
                int val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        case paramType::TArrayOfint:
            {
                nsTArray<int> val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        case paramType::TArrayOfPTestArraysSubParent:
            {
                uint32 len;
                const intptr_t* ptr;
                nsTArray<PTestArraysSubChild*> val;

                if ((!(ReadParam(aMsg, aIter, (&(len)))))) {
                    return false;
                }
                if ((!((aMsg)->ReadBytes(aIter, reinterpret_cast<const char**>((&(ptr))), (len) * (sizeof(intptr_t)))))) {
                    return false;
                }
                (val).InsertElementsAt(0, const_cast<PTestArraysSubChild**>(reinterpret_cast<const PTestArraysSubChild* const*>(ptr)), len);
                (*(aParam)) = val;
                return true;
            }
        case paramType::TArrayOfPTestArraysSubChild:
            {
                uint32 len;
                const intptr_t* ptr;
                nsTArray<PTestArraysSubParent*> val;

                if ((!(ReadParam(aMsg, aIter, (&(len)))))) {
                    return false;
                }
                if ((!((aMsg)->ReadBytes(aIter, reinterpret_cast<const char**>((&(ptr))), (len) * (sizeof(intptr_t)))))) {
                    return false;
                }
                (val).InsertElementsAt(0, const_cast<PTestArraysSubParent**>(reinterpret_cast<const PTestArraysSubParent* const*>(ptr)), len);
                (*(aParam)) = val;
                return true;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return false;
            }
        }

    }

    static void
    Log(
            const paramType& aParam,
            std::wstring* aLog)
    {
        (aLog)->append(L"(Actors)");
    }
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Definition of the IPDL type |union Unions|
//
namespace mozilla {
namespace _ipdltest {
class PTestArraysSubParent;
} // namespace _ipdltest
} // namespace mozilla

namespace mozilla {
namespace _ipdltest {
class PTestArraysSubChild;
} // namespace _ipdltest
} // namespace mozilla

namespace mozilla {
namespace _ipdltest {
class NS_FINAL_CLASS Unions
{
public:
    enum Type {
        T__None,
        Tint = 1,
        TArrayOfint,
        TArrayOfPTestArraysSubParent,
        TArrayOfPTestArraysSubChild,
        TArrayOfActors,
        T__First = Tint,
        T__Last = TArrayOfActors
    };

private:
    typedef mozilla::_ipdltest::PTestArraysSubParent PTestArraysSubParent;
    typedef mozilla::_ipdltest::PTestArraysSubChild PTestArraysSubChild;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef int int__tdef;
    typedef nsTArray<int> ArrayOfint__tdef;
    typedef nsTArray<PTestArraysSubParent*> ArrayOfPTestArraysSubParent__tdef;
    typedef nsTArray<PTestArraysSubChild*> ArrayOfPTestArraysSubChild__tdef;
    typedef nsTArray<Actors> ArrayOfActors__tdef;

    union Value {
        char Vint[sizeof(int)];
        char VArrayOfint[sizeof(nsTArray<int>)];
        char VArrayOfPTestArraysSubParent[sizeof(nsTArray<PTestArraysSubParent*>)];
        char VArrayOfPTestArraysSubChild[sizeof(nsTArray<PTestArraysSubChild*>)];
        char VArrayOfActors[sizeof(nsTArray<Actors>)];
    };

    int*
    ptr_int()
    {
        return reinterpret_cast<int*>((&((mValue).Vint)));
    }
    const int* const
    constptr_int() const
    {
        return reinterpret_cast<const int* const>((&((mValue).Vint)));
    }
    nsTArray<int>*
    ptr_ArrayOfint()
    {
        return reinterpret_cast<nsTArray<int>*>((&((mValue).VArrayOfint)));
    }
    const nsTArray<int>* const
    constptr_ArrayOfint() const
    {
        return reinterpret_cast<const nsTArray<int>* const>((&((mValue).VArrayOfint)));
    }
    nsTArray<PTestArraysSubParent*>*
    ptr_ArrayOfPTestArraysSubParent()
    {
        return reinterpret_cast<nsTArray<PTestArraysSubParent*>*>((&((mValue).VArrayOfPTestArraysSubParent)));
    }
    const nsTArray<PTestArraysSubParent*>* const
    constptr_ArrayOfPTestArraysSubParent() const
    {
        return reinterpret_cast<const nsTArray<PTestArraysSubParent*>* const>((&((mValue).VArrayOfPTestArraysSubParent)));
    }
    nsTArray<PTestArraysSubChild*>*
    ptr_ArrayOfPTestArraysSubChild()
    {
        return reinterpret_cast<nsTArray<PTestArraysSubChild*>*>((&((mValue).VArrayOfPTestArraysSubChild)));
    }
    const nsTArray<PTestArraysSubChild*>* const
    constptr_ArrayOfPTestArraysSubChild() const
    {
        return reinterpret_cast<const nsTArray<PTestArraysSubChild*>* const>((&((mValue).VArrayOfPTestArraysSubChild)));
    }
    nsTArray<Actors>*
    ptr_ArrayOfActors()
    {
        return reinterpret_cast<nsTArray<Actors>*>((&((mValue).VArrayOfActors)));
    }
    const nsTArray<Actors>* const
    constptr_ArrayOfActors() const
    {
        return reinterpret_cast<const nsTArray<Actors>* const>((&((mValue).VArrayOfActors)));
    }

    bool
    MaybeDestroy(Type aNewType)
    {
        if ((mType) == (T__None)) {
            return true;
        }
        if ((mType) == (aNewType)) {
            return false;
        }
        switch (mType) {
        case Tint:
            {
                (ptr_int())->~int__tdef();
                break;
            }
        case TArrayOfint:
            {
                (ptr_ArrayOfint())->~ArrayOfint__tdef();
                break;
            }
        case TArrayOfPTestArraysSubParent:
            {
                (ptr_ArrayOfPTestArraysSubParent())->~ArrayOfPTestArraysSubParent__tdef();
                break;
            }
        case TArrayOfPTestArraysSubChild:
            {
                (ptr_ArrayOfPTestArraysSubChild())->~ArrayOfPTestArraysSubChild__tdef();
                break;
            }
        case TArrayOfActors:
            {
                (ptr_ArrayOfActors())->~ArrayOfActors__tdef();
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("not reached");
                break;
            }
        }
        return true;
    }

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__First) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    Unions() :
        mType(T__None)
    {
    }

    Unions(const int& aOther)
    {
        new (ptr_int()) int(aOther);
        mType = Tint;
    }

    Unions(const nsTArray<int>& aOther)
    {
        new (ptr_ArrayOfint()) nsTArray<int>(aOther);
        mType = TArrayOfint;
    }

    Unions(const nsTArray<PTestArraysSubParent*>& aOther)
    {
        new (ptr_ArrayOfPTestArraysSubParent()) nsTArray<PTestArraysSubParent*>(aOther);
        mType = TArrayOfPTestArraysSubParent;
    }

    Unions(const nsTArray<PTestArraysSubChild*>& aOther)
    {
        new (ptr_ArrayOfPTestArraysSubChild()) nsTArray<PTestArraysSubChild*>(aOther);
        mType = TArrayOfPTestArraysSubChild;
    }

    Unions(const nsTArray<Actors>& aOther)
    {
        new (ptr_ArrayOfActors()) nsTArray<Actors>(aOther);
        mType = TArrayOfActors;
    }

    Unions(const Unions& aOther)
    {
        (aOther).AssertSanity();
        switch ((aOther).type()) {
        case Tint:
            {
                new (ptr_int()) int((aOther).get_int());
                break;
            }
        case TArrayOfint:
            {
                new (ptr_ArrayOfint()) nsTArray<int>((aOther).get_ArrayOfint());
                break;
            }
        case TArrayOfPTestArraysSubParent:
            {
                new (ptr_ArrayOfPTestArraysSubParent()) nsTArray<PTestArraysSubParent*>((aOther).get_ArrayOfPTestArraysSubParent());
                break;
            }
        case TArrayOfPTestArraysSubChild:
            {
                new (ptr_ArrayOfPTestArraysSubChild()) nsTArray<PTestArraysSubChild*>((aOther).get_ArrayOfPTestArraysSubChild());
                break;
            }
        case TArrayOfActors:
            {
                new (ptr_ArrayOfActors()) nsTArray<Actors>((aOther).get_ArrayOfActors());
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return;
            }
        }
        mType = (aOther).type();
    }

    ~Unions()
    {
        MaybeDestroy(T__None);
    }

    Type
    type() const
    {
        return mType;
    }

    Unions&
    operator=(const int& aRhs)
    {
        if (MaybeDestroy(Tint)) {
            new (ptr_int()) int;
        }
        (*(ptr_int())) = aRhs;
        mType = Tint;
        return (*(this));
    }

    Unions&
    operator=(const nsTArray<int>& aRhs)
    {
        if (MaybeDestroy(TArrayOfint)) {
            new (ptr_ArrayOfint()) nsTArray<int>;
        }
        (*(ptr_ArrayOfint())) = aRhs;
        mType = TArrayOfint;
        return (*(this));
    }

    Unions&
    operator=(const nsTArray<PTestArraysSubParent*>& aRhs)
    {
        if (MaybeDestroy(TArrayOfPTestArraysSubParent)) {
            new (ptr_ArrayOfPTestArraysSubParent()) nsTArray<PTestArraysSubParent*>;
        }
        (*(ptr_ArrayOfPTestArraysSubParent())) = aRhs;
        mType = TArrayOfPTestArraysSubParent;
        return (*(this));
    }

    Unions&
    operator=(const nsTArray<PTestArraysSubChild*>& aRhs)
    {
        if (MaybeDestroy(TArrayOfPTestArraysSubChild)) {
            new (ptr_ArrayOfPTestArraysSubChild()) nsTArray<PTestArraysSubChild*>;
        }
        (*(ptr_ArrayOfPTestArraysSubChild())) = aRhs;
        mType = TArrayOfPTestArraysSubChild;
        return (*(this));
    }

    Unions&
    operator=(const nsTArray<Actors>& aRhs)
    {
        if (MaybeDestroy(TArrayOfActors)) {
            new (ptr_ArrayOfActors()) nsTArray<Actors>;
        }
        (*(ptr_ArrayOfActors())) = aRhs;
        mType = TArrayOfActors;
        return (*(this));
    }

    Unions&
    operator=(const Unions& aRhs)
    {
        (aRhs).AssertSanity();
        Type t = (aRhs).type();
        switch (t) {
        case Tint:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_int()) int;
                }
                (*(ptr_int())) = (aRhs).get_int();
                break;
            }
        case TArrayOfint:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_ArrayOfint()) nsTArray<int>;
                }
                (*(ptr_ArrayOfint())) = (aRhs).get_ArrayOfint();
                break;
            }
        case TArrayOfPTestArraysSubParent:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_ArrayOfPTestArraysSubParent()) nsTArray<PTestArraysSubParent*>;
                }
                (*(ptr_ArrayOfPTestArraysSubParent())) = (aRhs).get_ArrayOfPTestArraysSubParent();
                break;
            }
        case TArrayOfPTestArraysSubChild:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_ArrayOfPTestArraysSubChild()) nsTArray<PTestArraysSubChild*>;
                }
                (*(ptr_ArrayOfPTestArraysSubChild())) = (aRhs).get_ArrayOfPTestArraysSubChild();
                break;
            }
        case TArrayOfActors:
            {
                if (MaybeDestroy(t)) {
                    new (ptr_ArrayOfActors()) nsTArray<Actors>;
                }
                (*(ptr_ArrayOfActors())) = (aRhs).get_ArrayOfActors();
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                break;
            }
        }
        mType = t;
        return (*(this));
    }

    int&
    get_int()
    {
        AssertSanity(Tint);
        return (*(ptr_int()));
    }
    const int&
    get_int() const
    {
        AssertSanity(Tint);
        return (*(constptr_int()));
    }
    operator int&()
    {
        return get_int();
    }
    operator const int&() const
    {
        return get_int();
    }

    nsTArray<int>&
    get_ArrayOfint()
    {
        AssertSanity(TArrayOfint);
        return (*(ptr_ArrayOfint()));
    }
    const nsTArray<int>&
    get_ArrayOfint() const
    {
        AssertSanity(TArrayOfint);
        return (*(constptr_ArrayOfint()));
    }
    operator nsTArray<int>&()
    {
        return get_ArrayOfint();
    }
    operator const nsTArray<int>&() const
    {
        return get_ArrayOfint();
    }

    nsTArray<PTestArraysSubParent*>&
    get_ArrayOfPTestArraysSubParent()
    {
        AssertSanity(TArrayOfPTestArraysSubParent);
        return (*(ptr_ArrayOfPTestArraysSubParent()));
    }
    const nsTArray<PTestArraysSubParent*>&
    get_ArrayOfPTestArraysSubParent() const
    {
        AssertSanity(TArrayOfPTestArraysSubParent);
        return (*(constptr_ArrayOfPTestArraysSubParent()));
    }
    operator nsTArray<PTestArraysSubParent*>&()
    {
        return get_ArrayOfPTestArraysSubParent();
    }
    operator const nsTArray<PTestArraysSubParent*>&() const
    {
        return get_ArrayOfPTestArraysSubParent();
    }

    nsTArray<PTestArraysSubChild*>&
    get_ArrayOfPTestArraysSubChild()
    {
        AssertSanity(TArrayOfPTestArraysSubChild);
        return (*(ptr_ArrayOfPTestArraysSubChild()));
    }
    const nsTArray<PTestArraysSubChild*>&
    get_ArrayOfPTestArraysSubChild() const
    {
        AssertSanity(TArrayOfPTestArraysSubChild);
        return (*(constptr_ArrayOfPTestArraysSubChild()));
    }
    operator nsTArray<PTestArraysSubChild*>&()
    {
        return get_ArrayOfPTestArraysSubChild();
    }
    operator const nsTArray<PTestArraysSubChild*>&() const
    {
        return get_ArrayOfPTestArraysSubChild();
    }

    nsTArray<Actors>&
    get_ArrayOfActors()
    {
        AssertSanity(TArrayOfActors);
        return (*(ptr_ArrayOfActors()));
    }
    const nsTArray<Actors>&
    get_ArrayOfActors() const
    {
        AssertSanity(TArrayOfActors);
        return (*(constptr_ArrayOfActors()));
    }
    operator nsTArray<Actors>&()
    {
        return get_ArrayOfActors();
    }
    operator const nsTArray<Actors>&() const
    {
        return get_ArrayOfActors();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace _ipdltest
} // namespace mozilla

//
// serializer/deserializer
//
namespace IPC {
template<>
struct ParamTraits <mozilla::_ipdltest::Unions>
{
private:
    typedef mozilla::_ipdltest::PTestArraysSubParent PTestArraysSubParent;
    typedef mozilla::_ipdltest::PTestArraysSubChild PTestArraysSubChild;
    typedef mozilla::_ipdltest::Actors Actors;

public:
    typedef mozilla::_ipdltest::Unions paramType;

    static void
    Write(
            Message* aMsg,
            const paramType& aParam)
    {
        WriteParam(aMsg, static_cast<int>((aParam).type()));
        switch ((aParam).type()) {
        case paramType::Tint:
            {
                WriteParam(aMsg, (aParam).get_int());
                break;
            }
        case paramType::TArrayOfint:
            {
                WriteParam(aMsg, (aParam).get_ArrayOfint());
                break;
            }
        case paramType::TArrayOfPTestArraysSubParent:
            {
                uint32 len = ((aParam).get_ArrayOfPTestArraysSubParent()).Length();
                WriteParam(aMsg, len);
                (aMsg)->WriteBytes(reinterpret_cast<const void*>(((aParam).get_ArrayOfPTestArraysSubParent()).Elements()), (len) * (sizeof(intptr_t)));
                break;
            }
        case paramType::TArrayOfPTestArraysSubChild:
            {
                uint32 len = ((aParam).get_ArrayOfPTestArraysSubChild()).Length();
                WriteParam(aMsg, len);
                (aMsg)->WriteBytes(reinterpret_cast<const void*>(((aParam).get_ArrayOfPTestArraysSubChild()).Elements()), (len) * (sizeof(intptr_t)));
                break;
            }
        case paramType::TArrayOfActors:
            {
                WriteParam(aMsg, (aParam).get_ArrayOfActors());
                break;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return;
            }
        }
    }

    static bool
    Read(
            const Message* aMsg,
            void** aIter,
            paramType* aParam)
    {
        int type;
        if ((!((ReadParam(aMsg, aIter, (&(type)))) && (((paramType::T__First) <= (type)) && ((type) <= (paramType::T__Last)))))) {
            return false;
        }

        switch (type) {
        case paramType::Tint:
            {
                int val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        case paramType::TArrayOfint:
            {
                nsTArray<int> val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        case paramType::TArrayOfPTestArraysSubParent:
            {
                uint32 len;
                const intptr_t* ptr;
                nsTArray<PTestArraysSubChild*> val;

                if ((!(ReadParam(aMsg, aIter, (&(len)))))) {
                    return false;
                }
                if ((!((aMsg)->ReadBytes(aIter, reinterpret_cast<const char**>((&(ptr))), (len) * (sizeof(intptr_t)))))) {
                    return false;
                }
                (val).InsertElementsAt(0, const_cast<PTestArraysSubChild**>(reinterpret_cast<const PTestArraysSubChild* const*>(ptr)), len);
                (*(aParam)) = val;
                return true;
            }
        case paramType::TArrayOfPTestArraysSubChild:
            {
                uint32 len;
                const intptr_t* ptr;
                nsTArray<PTestArraysSubParent*> val;

                if ((!(ReadParam(aMsg, aIter, (&(len)))))) {
                    return false;
                }
                if ((!((aMsg)->ReadBytes(aIter, reinterpret_cast<const char**>((&(ptr))), (len) * (sizeof(intptr_t)))))) {
                    return false;
                }
                (val).InsertElementsAt(0, const_cast<PTestArraysSubParent**>(reinterpret_cast<const PTestArraysSubParent* const*>(ptr)), len);
                (*(aParam)) = val;
                return true;
            }
        case paramType::TArrayOfActors:
            {
                nsTArray<Actors> val;

                if ((!(ReadParam(aMsg, aIter, (&(val)))))) {
                    return false;
                }
                (*(aParam)) = val;
                return true;
            }
        default:
            {
                NS_RUNTIMEABORT("unreached");
                return false;
            }
        }

    }

    static void
    Log(
            const paramType& aParam,
            std::wstring* aLog)
    {
        (aLog)->append(L"(Unions)");
    }
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Code common to PTestArraysChild and PTestArraysParent
//
namespace mozilla {
namespace _ipdltest {
namespace PTestArrays {

enum State {
    State_START,
    State_TEST1,
    State_TEST2,
    State_TEST3,
    State_TEST4,
    State_TEST5,
    State_TEST6,
    State_TEST7,
    State_TEST8,
    State_TEST9,
    State_TEST10,
    State_DEAD,
    StateStart = State_START,
    StateError,
    StateLast
};

enum MessageType {
    PTestArraysStart = PTestArraysMsgStart << 10,
    PTestArraysPreStart = (PTestArraysMsgStart << 10) - 1,
    Msg_PTestArraysSubConstructor__ID,
    Reply_PTestArraysSubConstructor__ID,
    Msg_Start__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_Test1__ID,
    Reply_Test1__ID,
    Msg_Test2__ID,
    Reply_Test2__ID,
    Msg_Test3__ID,
    Reply_Test3__ID,
    Msg_Test4__ID,
    Reply_Test4__ID,
    Msg_Test5__ID,
    Reply_Test5__ID,
    Msg_Test6__ID,
    Reply_Test6__ID,
    Msg_Test7__ID,
    Reply_Test7__ID,
    Msg_Test8__ID,
    Reply_Test8__ID,
    Msg_Test9__ID,
    Reply_Test9__ID,
    Msg_Test10__ID,
    Reply_Test10__ID,
    PTestArraysEnd
};

class Msg_PTestArraysSubConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_PTestArraysSubConstructor__ID
    };
    Msg_PTestArraysSubConstructor(
            const ActorHandle& actor,
            const int& i) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_PTestArraysSubConstructor")
    {
        IPC::WriteParam(this, actor);
        IPC::WriteParam(this, i);
    }

    static bool
    Read(
            const Message* msg,
            ActorHandle* actor,
            int* i)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), actor)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), i)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PTestArraysSubConstructor(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_PTestArraysSubConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_PTestArraysSubConstructor__ID
    };
    Reply_PTestArraysSubConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_PTestArraysSubConstructor")
    {
    }

    static bool
    Read(const Message* msg)
    {
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PTestArraysSubConstructor(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Start :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Start__ID
    };
    Msg_Start() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Start")
    {
    }

    static bool
    Read(const Message* msg)
    {
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Start(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__(const ActorHandle& actor) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg___delete__")
    {
        IPC::WriteParam(this, actor);
    }

    static bool
    Read(
            const Message* msg,
            ActorHandle* actor)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), actor)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply___delete__")
    {
    }

    static bool
    Read(const Message* msg)
    {
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test1 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test1__ID
    };
    Msg_Test1(const nsTArray<int>& i1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test1")
    {
        IPC::WriteParam(this, i1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<int>* i1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test1(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test1 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test1__ID
    };
    Reply_Test1(const nsTArray<int>& o1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test1")
    {
        IPC::WriteParam(this, o1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<int>* o1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test1(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test2 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test2__ID
    };
    Msg_Test2(const nsTArray<ActorHandle>& i1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test2")
    {
        IPC::WriteParam(this, i1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<ActorHandle>* i1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test2(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test2 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test2__ID
    };
    Reply_Test2(const nsTArray<ActorHandle>& o1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test2")
    {
        IPC::WriteParam(this, o1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<ActorHandle>* o1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test2(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test3 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test3__ID
    };
    Msg_Test3(
            const IntDouble& i1,
            const IntDouble& i2) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test3")
    {
        IPC::WriteParam(this, i1);
        IPC::WriteParam(this, i2);
    }

    static bool
    Read(
            const Message* msg,
            IntDouble* i1,
            IntDouble* i2)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), i2)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test3(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test3 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test3__ID
    };
    Reply_Test3(
            const IntDouble& o1,
            const IntDouble& o2) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test3")
    {
        IPC::WriteParam(this, o1);
        IPC::WriteParam(this, o2);
    }

    static bool
    Read(
            const Message* msg,
            IntDouble* o1,
            IntDouble* o2)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), o2)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test3(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test4 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test4__ID
    };
    Msg_Test4(const nsTArray<IntDouble>& i1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test4")
    {
        IPC::WriteParam(this, i1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<IntDouble>* i1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test4(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test4 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test4__ID
    };
    Reply_Test4(const nsTArray<IntDouble>& o1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test4")
    {
        IPC::WriteParam(this, o1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<IntDouble>* o1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test4(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test5 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test5__ID
    };
    Msg_Test5(
            const IntDoubleArrays& i1,
            const IntDoubleArrays& i2,
            const IntDoubleArrays& i3) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test5")
    {
        IPC::WriteParam(this, i1);
        IPC::WriteParam(this, i2);
        IPC::WriteParam(this, i3);
    }

    static bool
    Read(
            const Message* msg,
            IntDoubleArrays* i1,
            IntDoubleArrays* i2,
            IntDoubleArrays* i3)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), i2)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), i3)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test5(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test5 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test5__ID
    };
    Reply_Test5(
            const IntDoubleArrays& o1,
            const IntDoubleArrays& o2,
            const IntDoubleArrays& o3) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test5")
    {
        IPC::WriteParam(this, o1);
        IPC::WriteParam(this, o2);
        IPC::WriteParam(this, o3);
    }

    static bool
    Read(
            const Message* msg,
            IntDoubleArrays* o1,
            IntDoubleArrays* o2,
            IntDoubleArrays* o3)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), o2)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), o3)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test5(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test6 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test6__ID
    };
    Msg_Test6(const nsTArray<IntDoubleArrays>& i1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test6")
    {
        IPC::WriteParam(this, i1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<IntDoubleArrays>* i1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test6(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test6 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test6__ID
    };
    Reply_Test6(const nsTArray<IntDoubleArrays>& o1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test6")
    {
        IPC::WriteParam(this, o1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<IntDoubleArrays>* o1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test6(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test7 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test7__ID
    };
    Msg_Test7(
            const Actors& i1,
            const Actors& i2,
            const Actors& i3) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test7")
    {
        IPC::WriteParam(this, i1);
        IPC::WriteParam(this, i2);
        IPC::WriteParam(this, i3);
    }

    static bool
    Read(
            const Message* msg,
            Actors* i1,
            Actors* i2,
            Actors* i3)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), i2)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), i3)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test7(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test7 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test7__ID
    };
    Reply_Test7(
            const Actors& o1,
            const Actors& o2,
            const Actors& o3) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test7")
    {
        IPC::WriteParam(this, o1);
        IPC::WriteParam(this, o2);
        IPC::WriteParam(this, o3);
    }

    static bool
    Read(
            const Message* msg,
            Actors* o1,
            Actors* o2,
            Actors* o3)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), o2)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), o3)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test7(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test8 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test8__ID
    };
    Msg_Test8(const nsTArray<Actors>& i1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test8")
    {
        IPC::WriteParam(this, i1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<Actors>* i1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test8(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test8 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test8__ID
    };
    Reply_Test8(const nsTArray<Actors>& o1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test8")
    {
        IPC::WriteParam(this, o1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<Actors>* o1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test8(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test9 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test9__ID
    };
    Msg_Test9(
            const Unions& i1,
            const Unions& i2,
            const Unions& i3,
            const Unions& i4) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test9")
    {
        IPC::WriteParam(this, i1);
        IPC::WriteParam(this, i2);
        IPC::WriteParam(this, i3);
        IPC::WriteParam(this, i4);
    }

    static bool
    Read(
            const Message* msg,
            Unions* i1,
            Unions* i2,
            Unions* i3,
            Unions* i4)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), i2)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), i3)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), i4)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test9(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test9 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test9__ID
    };
    Reply_Test9(
            const Unions& o1,
            const Unions& o2,
            const Unions& o3,
            const Unions& o4) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test9")
    {
        IPC::WriteParam(this, o1);
        IPC::WriteParam(this, o2);
        IPC::WriteParam(this, o3);
        IPC::WriteParam(this, o4);
    }

    static bool
    Read(
            const Message* msg,
            Unions* o1,
            Unions* o2,
            Unions* o3,
            Unions* o4)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), o2)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), o3)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), o4)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test9(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Test10 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_Test10__ID
    };
    Msg_Test10(const nsTArray<Unions>& i1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Msg_Test10")
    {
        IPC::WriteParam(this, i1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<Unions>* i1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), i1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Test10(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Test10 :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::_ipdltest::IntDouble IntDouble;
    typedef mozilla::_ipdltest::IntDoubleArrays IntDoubleArrays;
    typedef mozilla::_ipdltest::Actors Actors;
    typedef mozilla::_ipdltest::Unions Unions;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply_Test10__ID
    };
    Reply_Test10(const nsTArray<Unions>& o1) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PTestArrays::Reply_Test10")
    {
        IPC::WriteParam(this, o1);
    }

    static bool
    Read(
            const Message* msg,
            nsTArray<Unions>* o1)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), o1)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Test10(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PTestArrays
} // namespace _ipdltest
} // namespace mozilla

#endif // ifndef PTestArrays_h
